# WEB+DB PRESS 連載「Goに入りては…… ── When In Go...」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.126」の連載「Goに入りては……」第28回「GoにFuzzingが来た！」（牧大輔著）のサンプルコードです。

# 実行方法

今回のサンプルはコンパイル・実行はできますが、特に有効な出力はされません。
あくまでコードを読むためにご利用ください。

サンプルを実行するにはGo 1.18標準ライブラリが必要です。
Go 1.18リリース前に実行される場合は`gotip`コマンドを利用して最新版のgoを入手してください

```
$ go install golang.org/dl/gotip@latest
$ gotip download
```

以下では`go`コマンドを利用しますが、上記の`gotip`を利用している場合は`gotip`で適時入れ替えを行ってください


最初に`go test`を実行してエラーはおこりません。

```
go test
```

`go test -fuzz=.`を実行すると、Fuzzingで`OutOfRange()`のエラーが見つかりパニックが起こります。

```
go test -fuzz=.
```

この際、エラーを起こしたデータは`testdata`ディレクトリに格納され、次回の`go test`から参照されるようになります。
（つまり、またエラーが起きます）

```
go test
```

その後関数が修正されたことを再現するために、`FIX`環境変数をつけてテストを実行するとエラーはそれ以降表示されません。

```
FIX=true go test
```
