package article_test

import (
	"encoding/json"
	"fmt"
	"log"
	"os"
	"strconv"
	"testing"
)

func OutOfRange(in []byte) error {
	if b, _ := strconv.ParseBool(os.Getenv(`FIX`)); b {
		var x struct {
			Hello string `json:"hello"`
		}
		if err := json.Unmarshal(in, &x); err != nil {
			return fmt.Errorf(`failed to unmarshal JSON: %w`, err)
		}
		return nil
	}
	// can only parse {"hello":"world"}
	hello := in[2:7]
	world := in[10:15]
	log.Printf("got %q, %q", hello, world)
	return nil
}

func TestOutOfRange(t *testing.T) {
	OutOfRange([]byte(`{"hello":"world"}`))
}

func FuzzOutOfRnage(f *testing.F) {
	f.Add([]byte(`{"hello":"world"}`))
	f.Fuzz(func(t *testing.T, in []byte) {
		log.Printf("Testing %q", in)
		OutOfRange(in)
	})
}
